"""
    Katalon TestOps API reference

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from testops_api.api_client import ApiClient, Endpoint
from testops_api.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from testops_api.model.execution_resource import ExecutionResource
from testops_api.model.test_run_result import TestRunResult
from testops_api.model.upload_batch_file_resource import UploadBatchFileResource
from testops_api.model.upload_batch_resource import UploadBatchResource


class TestReportApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __process_multiple_s3_file(
            self,
            project_id,
            batch,
            upload_batch_file_resource,
            **kwargs
        ):
            """Saves and processes multiple uploaded Katalon reports.  # noqa: E501

            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.process_multiple_s3_file(project_id, batch, upload_batch_file_resource, async_req=True)
            >>> result = thread.get()

            Args:
                project_id (int):
                batch (str):
                upload_batch_file_resource ([UploadBatchFileResource]):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [UploadBatchResource]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['project_id'] = \
                project_id
            kwargs['batch'] = \
                batch
            kwargs['upload_batch_file_resource'] = \
                upload_batch_file_resource
            return self.call_with_http_info(**kwargs)

        self.process_multiple_s3_file = Endpoint(
            settings={
                'response_type': ([UploadBatchResource],),
                'auth': [
                    'basicScheme'
                ],
                'endpoint_path': '/api/v1/katalon/test-reports/multiple',
                'operation_id': 'process_multiple_s3_file',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'project_id',
                    'batch',
                    'upload_batch_file_resource',
                ],
                'required': [
                    'project_id',
                    'batch',
                    'upload_batch_file_resource',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'project_id':
                        (int,),
                    'batch':
                        (str,),
                    'upload_batch_file_resource':
                        ([UploadBatchFileResource],),
                },
                'attribute_map': {
                    'project_id': 'projectId',
                    'batch': 'batch',
                },
                'location_map': {
                    'project_id': 'query',
                    'batch': 'query',
                    'upload_batch_file_resource': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    '*/*'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__process_multiple_s3_file
        )

        def __process_s3_file(
            self,
            project_id,
            batch,
            folder_path,
            is_end,
            file_name,
            uploaded_path,
            **kwargs
        ):
            """Saves and processes the uploaded Katalon reports.  # noqa: E501

            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.process_s3_file(project_id, batch, folder_path, is_end, file_name, uploaded_path, async_req=True)
            >>> result = thread.get()

            Args:
                project_id (str):
                batch (str):
                folder_path (str):
                is_end (str):
                file_name (str):
                uploaded_path (str):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [UploadBatchResource]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['project_id'] = \
                project_id
            kwargs['batch'] = \
                batch
            kwargs['folder_path'] = \
                folder_path
            kwargs['is_end'] = \
                is_end
            kwargs['file_name'] = \
                file_name
            kwargs['uploaded_path'] = \
                uploaded_path
            return self.call_with_http_info(**kwargs)

        self.process_s3_file = Endpoint(
            settings={
                'response_type': ([UploadBatchResource],),
                'auth': [
                    'basicScheme'
                ],
                'endpoint_path': '/api/v1/katalon/test-reports',
                'operation_id': 'process_s3_file',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'project_id',
                    'batch',
                    'folder_path',
                    'is_end',
                    'file_name',
                    'uploaded_path',
                ],
                'required': [
                    'project_id',
                    'batch',
                    'folder_path',
                    'is_end',
                    'file_name',
                    'uploaded_path',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'project_id':
                        (str,),
                    'batch':
                        (str,),
                    'folder_path':
                        (str,),
                    'is_end':
                        (str,),
                    'file_name':
                        (str,),
                    'uploaded_path':
                        (str,),
                },
                'attribute_map': {
                    'project_id': 'projectId',
                    'batch': 'batch',
                    'folder_path': 'folderPath',
                    'is_end': 'isEnd',
                    'file_name': 'fileName',
                    'uploaded_path': 'uploadedPath',
                },
                'location_map': {
                    'project_id': 'query',
                    'batch': 'query',
                    'folder_path': 'query',
                    'is_end': 'query',
                    'file_name': 'query',
                    'uploaded_path': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    '*/*'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__process_s3_file
        )

        def __process_test_ops_reports(
            self,
            project_id,
            batch,
            upload_batch_file_resource,
            **kwargs
        ):
            """Saves and processes multiple uploaded TestOps reports.  # noqa: E501

            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.process_test_ops_reports(project_id, batch, upload_batch_file_resource, async_req=True)
            >>> result = thread.get()

            Args:
                project_id (int):
                batch (str):
                upload_batch_file_resource ([UploadBatchFileResource]):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                UploadBatchResource
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['project_id'] = \
                project_id
            kwargs['batch'] = \
                batch
            kwargs['upload_batch_file_resource'] = \
                upload_batch_file_resource
            return self.call_with_http_info(**kwargs)

        self.process_test_ops_reports = Endpoint(
            settings={
                'response_type': (UploadBatchResource,),
                'auth': [
                    'basicScheme'
                ],
                'endpoint_path': '/api/v1/testops-reports',
                'operation_id': 'process_test_ops_reports',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'project_id',
                    'batch',
                    'upload_batch_file_resource',
                ],
                'required': [
                    'project_id',
                    'batch',
                    'upload_batch_file_resource',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'project_id':
                        (int,),
                    'batch':
                        (str,),
                    'upload_batch_file_resource':
                        ([UploadBatchFileResource],),
                },
                'attribute_map': {
                    'project_id': 'projectId',
                    'batch': 'batch',
                },
                'location_map': {
                    'project_id': 'query',
                    'batch': 'query',
                    'upload_batch_file_resource': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    '*/*'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__process_test_ops_reports
        )

        def __update_result(
            self,
            project_id,
            test_run_result,
            **kwargs
        ):
            """update_result  # noqa: E501

            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.update_result(project_id, test_run_result, async_req=True)
            >>> result = thread.get()

            Args:
                project_id (int):
                test_run_result (TestRunResult):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ExecutionResource
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['project_id'] = \
                project_id
            kwargs['test_run_result'] = \
                test_run_result
            return self.call_with_http_info(**kwargs)

        self.update_result = Endpoint(
            settings={
                'response_type': (ExecutionResource,),
                'auth': [
                    'basicScheme'
                ],
                'endpoint_path': '/api/v1/katalon/test-reports/update-result',
                'operation_id': 'update_result',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'project_id',
                    'test_run_result',
                ],
                'required': [
                    'project_id',
                    'test_run_result',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'project_id':
                        (int,),
                    'test_run_result':
                        (TestRunResult,),
                },
                'attribute_map': {
                    'project_id': 'projectId',
                },
                'location_map': {
                    'project_id': 'query',
                    'test_run_result': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    '*/*'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__update_result
        )

        def __upload_j_unit_reports(
            self,
            project_id,
            batch,
            folder_path,
            is_end,
            file_name,
            uploaded_path,
            **kwargs
        ):
            """Uploads and processes the JUnit reports to an Execution.  # noqa: E501

            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.upload_j_unit_reports(project_id, batch, folder_path, is_end, file_name, uploaded_path, async_req=True)
            >>> result = thread.get()

            Args:
                project_id (str):
                batch (str):
                folder_path (str):
                is_end (str):
                file_name (str):
                uploaded_path (str):

            Keyword Args:
                session_id (str): [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                None
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['project_id'] = \
                project_id
            kwargs['batch'] = \
                batch
            kwargs['folder_path'] = \
                folder_path
            kwargs['is_end'] = \
                is_end
            kwargs['file_name'] = \
                file_name
            kwargs['uploaded_path'] = \
                uploaded_path
            return self.call_with_http_info(**kwargs)

        self.upload_j_unit_reports = Endpoint(
            settings={
                'response_type': None,
                'auth': [
                    'basicScheme'
                ],
                'endpoint_path': '/api/v1/junit/test-reports',
                'operation_id': 'upload_j_unit_reports',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'project_id',
                    'batch',
                    'folder_path',
                    'is_end',
                    'file_name',
                    'uploaded_path',
                    'session_id',
                ],
                'required': [
                    'project_id',
                    'batch',
                    'folder_path',
                    'is_end',
                    'file_name',
                    'uploaded_path',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'project_id':
                        (str,),
                    'batch':
                        (str,),
                    'folder_path':
                        (str,),
                    'is_end':
                        (str,),
                    'file_name':
                        (str,),
                    'uploaded_path':
                        (str,),
                    'session_id':
                        (str,),
                },
                'attribute_map': {
                    'project_id': 'projectId',
                    'batch': 'batch',
                    'folder_path': 'folderPath',
                    'is_end': 'isEnd',
                    'file_name': 'fileName',
                    'uploaded_path': 'uploadedPath',
                    'session_id': 'sessionId',
                },
                'location_map': {
                    'project_id': 'query',
                    'batch': 'query',
                    'folder_path': 'query',
                    'is_end': 'query',
                    'file_name': 'query',
                    'uploaded_path': 'query',
                    'session_id': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [],
                'content_type': [],
            },
            api_client=api_client,
            callable=__upload_j_unit_reports
        )

        def __upload_test_ng_reports(
            self,
            execution_id,
            project_id,
            batch,
            folder_path,
            is_end,
            file_name,
            uploaded_path,
            **kwargs
        ):
            """Uploads and processes the TestNG reports to an execution.  # noqa: E501

            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.upload_test_ng_reports(execution_id, project_id, batch, folder_path, is_end, file_name, uploaded_path, async_req=True)
            >>> result = thread.get()

            Args:
                execution_id (int):
                project_id (int):
                batch (str):
                folder_path (str):
                is_end (bool):
                file_name (str):
                uploaded_path (str):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                None
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['execution_id'] = \
                execution_id
            kwargs['project_id'] = \
                project_id
            kwargs['batch'] = \
                batch
            kwargs['folder_path'] = \
                folder_path
            kwargs['is_end'] = \
                is_end
            kwargs['file_name'] = \
                file_name
            kwargs['uploaded_path'] = \
                uploaded_path
            return self.call_with_http_info(**kwargs)

        self.upload_test_ng_reports = Endpoint(
            settings={
                'response_type': None,
                'auth': [
                    'basicScheme'
                ],
                'endpoint_path': '/api/v1/testng/test-reports',
                'operation_id': 'upload_test_ng_reports',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'execution_id',
                    'project_id',
                    'batch',
                    'folder_path',
                    'is_end',
                    'file_name',
                    'uploaded_path',
                ],
                'required': [
                    'execution_id',
                    'project_id',
                    'batch',
                    'folder_path',
                    'is_end',
                    'file_name',
                    'uploaded_path',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'execution_id':
                        (int,),
                    'project_id':
                        (int,),
                    'batch':
                        (str,),
                    'folder_path':
                        (str,),
                    'is_end':
                        (bool,),
                    'file_name':
                        (str,),
                    'uploaded_path':
                        (str,),
                },
                'attribute_map': {
                    'execution_id': 'executionId',
                    'project_id': 'projectId',
                    'batch': 'batch',
                    'folder_path': 'folderPath',
                    'is_end': 'isEnd',
                    'file_name': 'fileName',
                    'uploaded_path': 'uploadedPath',
                },
                'location_map': {
                    'execution_id': 'query',
                    'project_id': 'query',
                    'batch': 'query',
                    'folder_path': 'query',
                    'is_end': 'query',
                    'file_name': 'query',
                    'uploaded_path': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [],
                'content_type': [],
            },
            api_client=api_client,
            callable=__upload_test_ng_reports
        )
